Subject: RE: [Sip] Session timer question

From: "Drage, Keith (Keith)" <[email-masked]>
Date: Mon, 1 Dec 2003 18:41:05 -0000

I think this is answered by subclause 8.2.4 of RFC 3261, viz:

8.2.4 Applying Extensions

   A UAS that wishes to apply some extension when generating the
   response MUST NOT do so unless support for that extension is
   indicated in the Supported header field in the request.  If the
   desired extension is not supported, the server SHOULD rely only on
   baseline SIP and any other extensions supported by the client.  In
   rare circumstances, where the server cannot process the request
   without the extension, the server MAY send a 421 (Extension Required)
   response.  This response indicates that the proper response cannot be
   generated without support of a specific extension.  The needed
   extension(s) MUST be included in a Require header field in the
   response.  This behavior is NOT RECOMMENDED, as it will generally
   break interoperability.

   Any extensions applied to a non-421 response MUST be listed in a
   Require header field included in the response.  Of course, the server
   MUST NOT apply extensions not listed in the Supported header field in
   the request.  As a result of this, the Require header field in a
   response will only ever contain option tags defined in standards-
   track RFCs.

regards

Keith

> -----Original Message-----
> From: Veda Hegde [mailto:[email-masked]]
> Sent: 01 December 2003 18:27
> To: Paul Kyzivat; Rosen Brian
> Cc: [email-masked]
> Subject: Re: [Sip] Session timer question
> 
> 
> Hi:
> I don't think it says in the draft that a proxy/UAS can not 
> put Require:
> timer in 2xx, if UAC did not include Supported: timer in the request.
> May be this should be specified in the draft.
> Veda
> 
> 
> ----- Original Message -----
> From: "Paul Kyzivat" <[email-masked]>
> To: "Rosen, Brian" <[email-masked]>
> Cc: <[email-masked]>; <[email-masked]>
> Sent: Monday, December 01, 2003 7:36 AM
> Subject: Re: [Sip] Session timer question
> 
> 
> > Brian,
> >
> > The question was about a Require in a 200 response to an 
> invite. The UAC
> > clearly can't return a 420 in that case.
> >
> > I don't think any valid usage of session timer will ever 
> result in this
> > case. The only cases where Require: timer is validly put into the
> > response are when the request contained Supported: timer.
> >
> > So this can only result from a broken proxy or UAS. In this 
> case I think
> > the UAC is justified in either sending an ACK and then BYE as you
> > suggest, or else just ignoring the Required: timer.
> >
> > Paul
> >
> > Rosen, Brian wrote:
> > > You send 420  - Bad Extension, because you don't understand the
> > > timer option in the Require.  See section 8.2.2.3 in RFC3261.
> > >
> > > Brian
> > > -----Original Message-----
> > > From: [email-masked] [mailto:[email-masked]]
> > > Sent: Friday, November 28, 2003 9:13 PM
> > > To: [email-masked]
> > > Subject: [Sip] Session timer question
> > >
> > >
> > > Hi:
> > > I have a question on session timer message flow.
> > >
> > >  If a UA does not support session timer and if it receives
> > >
> > > Require: timer
> > > Session Expires: 3600
> > >
> > > in the 200 OK to re-INVITE what is the correct way to process this
> response?
> > >
> > >
> > > Should UAC Ack the 200 OK and then send a bye or ignore 
> the Require and
> > > session Expires: headers and continue with rest of the processing?
> > >
> > > Veda
> > >
> > > _______________________________________________
> > > Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> > > This list is for NEW development of the core SIP Protocol
> > > Use [email-masked] for questions on current sip
> > > Use [email-masked] for new developments on the 
> application of sip
> > >
> >
> >
> > _______________________________________________
> > Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> > This list is for NEW development of the core SIP Protocol
> > Use [email-masked] for questions on current sip
> > Use [email-masked] for new developments on the application of sip
> >
> 
> 
> 
> _______________________________________________
> Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> This list is for NEW development of the core SIP Protocol
> Use [email-masked] for questions on current sip
> Use [email-masked] for new developments on the application of sip
> 

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: "Veda Hegde" <[email-masked]>
Date: Mon, 1 Dec 2003 11:31:25 -0800

Keith:
Thanks for pointing this out and I will go with this in my implementation.

I think, the 2nd paragraph in "Overview of operation" in the draft should be
reworded.
It says,
----------------------------------------------------------------------------
---------
This extension has the property that it works even when only one UA
   in a dialog supports it. The processing steps differ for handling
   each of the four cases (UAC supports it, or doesn't, and UAS supports
   it, or doesn't).
----------------------------------------------------------------------------
--------

Doesn't this mean even if UAC does not support timer, UAS could support it?

Veda

----- Original Message -----
From: "Drage, Keith (Keith)" <[email-masked]>
To: "'Veda Hegde'" <[email-masked]>; "Paul Kyzivat" <[email-masked]>;
"Rosen Brian" <[email-masked]>
Cc: <[email-masked]>
Sent: Monday, December 01, 2003 10:41 AM
Subject: RE: [Sip] Session timer question

---

From: Jonathan Rosenberg <[email-masked]>
Date: Fri, 05 Dec 2003 15:01:14 -0500

inline.

Veda Hegde wrote:

> Keith: Thanks for pointing this out and I will go with this in my
> implementation.
> 
> I think, the 2nd paragraph in "Overview of operation" in the draft
> should be reworded. It says, 
>  --------- This extension has the property that it works even when
> only one UA in a dialog supports it. The processing steps differ
> for handling each of the four cases (UAC supports it, or doesn't,
> and UAS supports it, or doesn't). 

Yes, and this mode is supported. In such a case, the INVITE from the 
UAC would lack a Supported header field. Proxies insert 
Session-Expires headers. The UAS receives it. Based on table 2 in the 
session timer spec, since the UAS supports the extension, it sets the 
refresher parameter to "uas", and generates a 2xx with the final 
session timer in the session expires header. This header is ignored by 
the UAC. The called party will generate refresh requests for the 
remainder of the call.

Note that there is no Require in the 2xx in this case.

-Jonathan R.

-- 
Jonathan D. Rosenberg, Ph.D.                600 Lanidex Plaza
Chief Technology Officer                    Parsippany, NJ 07054-2711
dynamicsoft
[email-masked]                     FAX:   (973) 952-5050
http://www.jdrosen.net                      PHONE: (973) 952-5000
http://www.dynamicsoft.com